<?php
	/*
	* GMapFP Plugin List of GMapFP places for Joomla! 3.x
	* Version J3_3P
	* Creation date: Mai 2016
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die;

class PlgContentGMapFP_List extends JPlugin
{
	public function onContentPrepare($context, &$article, &$params, $page = 0) {

		// Simple performance check to determine whether bot should process further
		if (strpos($article->text, 'gmapfp_list ') === false)
		{
			return true;
		}
		
		require_once (JPATH_SITE . '/components/com_gmapfp/helpers/route.php');
		
		//Insertion des entêtes GMapFP si non déjà fait.
		require_once JPATH_SITE.'/components/com_gmapfp/helpers/define.php';
		Define_ModelGMapFP::define_gmapfp(0, array('CSS', 'LIGHTBOX', 'APIV3'));
			
		$language 	= JFactory::getLanguage();
		$language->load('mod_gmapfp');

		// Expression to search for (positions)
		$regex		= '/{gmapfp_list (.*?)}/i';

		// Find all instances of plugin and put in $matches for gmapfp_list
		// $matches[0] is full pattern match, $matches[1] is the position
		preg_match_all($regex, $article->text, $matches, PREG_SET_ORDER);

		// No matches, skip this
		if ($matches)
		{
			foreach ($matches as $matche)
			{
				$str_replace = $matche[0];
				$matche = $matche[1];
				preg_match('/picture="[[:digit:]]*"/', $matche[1], $image);
					$image = @$image[0];
					$image = str_replace('picture=','',$image);
					$image = str_replace('"','',$image);
					if ($image==="") $image = 1;

				if (preg_match('/where="(.*?)"/', $matche, $wheres) or preg_match_all('/\bid\b="[[:digit:]]*"/', $matche, $ids) or preg_match_all('/catid="[[:digit:]]*"/', $matche, $catids) or preg_match_all('/markerid="[[:digit:]]*"/', $matche, $catids)) 
				{

					if (preg_match_all('/\bid\b="[[:digit:]]*"/', $matche, $ids)) {
						foreach($ids as $id)
						{
							$id = str_replace('id=','',$id);
							$id = str_replace('"','',$id);
						};
					}else{
						$id = array();
					};

					if (preg_match_all('/catid="[[:digit:]]*"/', $matche, $catids)) {
						foreach($catids as $catid)
						{
							$catid = str_replace('catid=','',$catid);
							$catid = str_replace('"','',$catid);
						};
					}else{
						$catid = array();
					};

					if (preg_match_all('/markerid="[[:digit:]]*"/', $matche, $markerids)) {
						foreach($markerids as $markerid)
						{
							$markerid = str_replace('markerid=','',$markerid);
							$markerid = str_replace('"','',$markerid);
						};
					}else{
						$markerid = array();
					};

					if (preg_match('/where="(.*?)"/', $matche, $wheres)) {
						foreach($wheres as $where)
						{
							$where = str_replace('where=','',$where);
							$where = str_replace('"','',$where);
						};
					}else{
						$where = array();
					};

					$output = '';
					$datas = $this->_load($id, $catid, $markerid, $where);
					switch ($this->params->get('target')) {
						case "_parent": 
							foreach ($datas as $data) {
								$output .='<div class="gmapfp_list_element" style="clear:both;"><a class="gmafp_list_plugin" target="_parent" href="'.JRoute::_(GMapFPHelperRoute::getArticleRoute($data->id.':'.$data->alias)).'" title="'.JText::_('GMAPFP_MORE_INFOS').'">'."\n";
								$style = '';
								if ($image && $data->img) {
									$output .='<img style="padding-right: 10px; float:left; height:'.$this->params->get('gmapfp_height_picture' ,'40').'px;" src='.JURI::base().'images/gmapfp/thumbsGMap/'.$data->img.' />'."\n";
								}
								$output .='<label>'.$data->nom.'</label>'."\n";
								$output .='</a></div>'."\n";
							}
							break;
						case "_new": 
							foreach ($datas as $data) {
								$output .='<div class="gmapfp_list_element" style="clear:both;"><a class="gmafp_list_plugin" target="_blank" href="'.JRoute::_(GMapFPHelperRoute::getArticleRoute($data->id.':'.$data->alias)).'" title="'.JText::_('GMAPFP_MORE_INFOS').'">'."\n";
								$style = '';
								if ($image && $data->img) {
									$output .='<img style="padding-right: 10px; float:left; height:'.$this->params->get('gmapfp_height_picture' ,'40').'px;" src='.JURI::base().'images/gmapfp/thumbsGMap/'.$data->img.' />'."\n";
								}
								$output .='<label>'.$data->nom.'</label>'."\n";
								$output .='</a></div>'."\n";
							}
							break;
						case "_modal": 
							foreach ($datas as $data) {
								$output .='<div class="gmapfp_list_element" style="clear:both;"><a class="gmafp_list_plugin" href="#" onclick="window.open(\''.JRoute::_(GMapFPHelperRoute::getArticleRoute($data->id.':'.$data->alias)).'\', \'\', \'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=650,height=500\')" title="'.JText::_('GMAPFP_MORE_INFOS').'">'."\n";
								$style = '';
								if ($image && $data->img) {
									$output .='<img style="padding-right: 10px; float:left; height:'.$this->params->get('gmapfp_height_picture' ,'40').'px;" src='.JURI::base().'images/gmapfp/thumbsGMap/'.$data->img.' />'."\n";
								}
								$output .='<label>'.$data->nom.'</label>'."\n";
								$output .='</a></div>'."\n";
							}
							break;
						default: 
							JHTML::_('behavior.modal');
							foreach ($datas as $data) {
								$map_link=JRoute::_(GMapFPHelperRoute::getArticleRoute($data->id.':'.$data->alias).'&tmpl=component', false);
								$read_more_link ='<a rel="{handler:\'iframe\', size: {x: gmapfp_largeur_lightbox, y: gmapfp_hauteur_lightbox}, classWindow: \'gmapfp_modal_windows\', classOverlay: \'gmapfp_modal_windows_overlay\'}" class="modal" href="'.$map_link.'"  title="'.JText::_('GMAPFP_MORE_INFOS').'">';
								$output .='<div class="gmapfp_list_element" style="clear:both;">'.$read_more_link."\n";
								$style = '';
								if ($image && $data->img) {
									$output .='<img style="padding-right: 10px; float:left; height:'.$this->params->get('gmapfp_height_picture' ,'40').'px;" src='.JURI::base().'images/gmapfp/thumbsGMap/'.$data->img.' />'."\n";
								}
								$output .='<label>'.$data->nom.'</label>'."\n";
								$output .='</a></div>'."\n";
							}
							break;
					}
					$article->text = str_replace($str_replace, $output, $article->text);
				}
			}
		}

	}

	private function _load($ids , $catids, $markerids, $wheres) {
		$db 		= JFactory::getDbo();
		$wheresOR 	= array();
        $now    	= JFactory::getDate();
        $nullDate 	= $db->getNullDate();
		
		$cat_markers = self::_catid_marker();
		
		foreach ($ids as $id)
			$wheresOR[] = $db->quoteName('id') . ' = ' . (int)$id;
		foreach ($catids as $catid)
			$wheresOR[] = $db->quoteName('catid') . ' = ' . (int)$catid;
		foreach ($markerids as $markerid) {
			$wheresOR[] = $db->quoteName('index_marqueur') . ' = ' . (int)$markerid;
			//recherche aussi dans la catid pour marqueur par défaut
			if (!empty($cat_markers[1]) && array_key_exists($markerid, $cat_markers[1]))
				foreach ($cat_markers[1][$markerid] as $tmp)
					$wheresOR[] = '(' . $db->quoteName('catid') . ' = ' . (int)$tmp . ' AND ' . $db->quoteName('index_marqueur') . ' = 0 )';
		}
		if 	(!empty($wheres))	$wheresOR[] = $wheres;
			
		$where = implode(' OR ',$wheresOR);

		// Filter by access level.
		$user	= JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		$where .= ' AND (access IN ('.$groups.') or (access = ""))';
		//
		
		$where .= ' AND published = 1';
        $where .= ' AND ( publish_up = \'\' OR publish_up = '.$db->Quote($nullDate).' OR publish_up <= '.$db->Quote($now).' )';

		$query = $db->getQuery(true)
		->select($db->quoteName(array('id','catid','nom','alias','img','index_marqueur')))
		->from($db->quoteName('#__gmapfp'))
		->where($where);
		$db->setQuery($query);
		$datas = $db->loadObjectList();

		foreach ($datas as $data) {
			if ($data->index_marqueur == 0)
				$data->index_marqueur = @$cat_markers[0][$data->catid];
		}

		return $datas;
	}
	
	private function _catid_marker() {
		$db = JFactory::getDbo();
		$result = array();
		
		$query = $db->getQuery(true)
		->select($db->quoteName(array('id','params')))
		->from($db->quoteName('#__categories'))
		->where($db->quoteName('extension').' = '.$db->quote('com_gmapfp'));
		$db->setQuery($query);
		$datas = $db->loadAssocList('id');
		
		foreach($datas as $key => $data) {
			$tmp = @json_decode($data['params'])->default_marqueur_categories;
			if ($tmp)
				$result[0][$key] = $tmp;
		}

		if ($result)
			foreach ($result[0] as $key => $data) {
				$result[1][$data][] = $key;
			}
		
		return $result;
	}
}
